#!/bin/sh

getPp() {
	pass=$(grep 'wpa_passphrase=' /etc/hostapd/hostapd.conf | sed 's/^.*=//')
	echo $pass
}


setPp () {
	local PASSPHRASE=$1
	
	if [ -z "$PASSPHRASE" ]
	then
			echo "No passphrase given!"
			echo "usage is ./changePass Passphrase"
			exit 1
	fi

	pass=$(echo "$PASSPHRASE" | sed -e 's/[\/&]/\\&/g')

	sudo sed -i "s|`cat /etc/hostapd/hostapd.conf | grep wpa_passphrase=`|wpa_passphrase=$pass|g" /etc/hostapd/hostapd.conf

	echo "Set of PWD was successfull"
}

getSsid() {
	ssid=$(grep 'ssid=' /etc/hostapd/hostapd.conf | sed 's/^.*=//')
	echo $ssid
}


setSsid () {
	local SSID=$1
	
	if [ -z "$SSID" ]
	then
		echo "No SSID  given!"
		echo "usage is ./changeSsid SSID"
		exit 1
	fi
	
	ssid=$(echo "$SSID" | sed -e 's/[\/&]/\\&/g')
	
	q=$(cat /etc/hostapd/hostapd.conf | grep "ssid=" -m 1 | sed -e 's/[]\/$*.^|[]/\\&/g')

	sudo sed -i "s|$q|ssid=$ssid|g" /etc/hostapd/hostapd.conf

	echo "Set of SSID was successfull"
}

reload () {
	echo "Restart hostapd service ..."
	sudo service hostapd stop
	sudo service udhcpd stop
	sudo systemctl daemon-reload
	sudo /etc/init.d/networking restart
	sudo service hostapd start
	sudo service udhcpd start
	echo "Done ..."
}

case "$1" in
	#getPp)
	#	getPp
	#;;
	setPp)
		setPp $2
	;;
	getSsid)
		getSsid
	;;
	setSsid)
		setSsid $2
	;;
	reload)
		reload
	;;
	*)
	echo "Usage: configAP { setPp PASSPHRASE | getSsid | setSsid SSID | reload }"
	exit 1
	;;
esac
exit 0
