#!/bin/sh
TARGET='../../config/maps'

getLog () {

	local LINES=$1
	
	makeParent
	
	if [ -z "$LINES" ]
	then
		echo "grep last 1000 lines"
		LINES=1000
	fi

	LOG=$(grep -oP '(?<=<log-file>).*?(?=</log-file>)' ../../config.xml)
	
	if [ -z "$LOG" ]
	then
		echo "No log found"
		exit 1
	fi
	
	echo 'LOG: ' $LOG
	now=$(date +"%Y%m%d%H%M")
	new='z-way-server_'$now'.log'
	echo $new
	
	cleanup
	
	tpath=$TARGET/$new
	
	sudo touch $tpath
	sudo tail -$LINES $LOG | sudo tee $tpath > /dev/null
	echo 'Successful ...'
}

removeLog () {

	makeParent
	cleanup
}

makeParent () {
	parent_path=$(dirname "$0")
	
	echo 'parent_path: ' $parent_path

	cd "$parent_path"
}

cleanup () {

	tpath=$TARGET"/z-way-server_*"

	if ls $tpath 1> /dev/null 2>&1; then
        echo 'Remove already existing log backups from zway config ...'
		sudo rm $tpath
    fi

}
case "$1" in
	getLog)
		getLog $2
	;;
	removeLog)
		removeLog
	;;
	*)
	echo "Usage: fetchLog { getLog LINES | removeLog}"
	exit 1
	;;
esac
exit 0