/* Copyright:  Trident IoT, Created: 01-04-2025 00:14:48 */
/**
 * @overview The object with default icons.
 * @author Martin Vach
 */

/**
 * Configuration object
 * @class icon_data
 */
var icon_data = {
    cfgicons: {
        element: {
            icon: {
                lock: {
                    level: {
                        open: 'lock-open.png',
                        closed: 'lock-closed.png'
                    }
                },
                door: {
                    level: {
                        open: 'door-open.png',
                        closed: 'door-closed.png'
                    }
                },
                window_tilt: {
                    level: {
                        open: 'window-up.png',
                        closed: 'window-down.png'
                    }
                },
                window: {
                    level: {
                        down: 'window-down.png',
                        half: 'window-half.png',
                        up: 'window-up.png',
                        open: 'window-open.png',
                        closed: 'window-closed.png',
                        on: 'window-open.png',
                        off: 'window-closed.png'
                    }
                },
                switch: {
                    level: {
                        on: 'switch-on.png',
                        off: 'switch-off.png'
                    }
                },
                siren: {
                    level: {
                        on: 'siren-on.png',
                        off: 'siren-off.png'
                    }
                },
                fan: {
                    level: {
                        on: 'fan-on.png',
                        half: 'fan-half.png',
                        off: 'fan-off.png'
                    }
                },
                motion: {
                    level: {
                        on: 'motion-on.png',
                        off: 'motion-off.png'
                    }
                },
                blinds: {
                    level: {
                        down: 'blind-down.png',
                        half: 'blind-half.png',
                        up: 'blind-up.png'
                    }
                },
                multilevel: {
                    level: {
                        on: 'dimmer-on.png',
                        half: 'dimmer-half.png',
                        off: 'dimmer-off.png'
                    }
                },
                doorlockcontrol: {
                    default: 'lock-closed.png'
                },
                thermostat: {
                    level: {
                        on: 'thermostat.png',
                        off: 'thermostat-off.png'
                    }
                },
                energy: {
                    default: 'energy.png'
                },
                meter: {
                    default: 'meter.png'
                },
                temperature: {
                    default: 'temperature.png'
                },
                camera: {
                    default: 'camera.png'
                },
                alarm_smoke: {
                    level: {
                        on: 'smoke-on.png',
                        off: 'smoke-off.png'
                    }
                },
                alarm: {
                    level: {
                        on: 'alarm-on.png',
                        off: 'alarm-off.png'
                    }
                },
                alarm_flood: {
                    level: {
                        on: 'flood-on.png',
                        off: 'flood-off.png'
                    }
                },
                alarm_burglar: {
                    level: {
                        on: 'burglar-alarm-on.png',
                        off: 'burglar-alarm-off.png'
                    }
                },
                battery: {
                    default: 'battery.png'
                },
                luminosity: {
                    default: 'luminosity.png'
                },
                humidity: {
                    default: 'humidity.png'
                },
                ultraviolet: {
                    default: 'ultraviolet.png'
                },
                barometer: {
                    default: 'barometer.png'
                },
                new: {
                    default: 'new.png'
                },
                rain: {
                    default: 'rain.png'
                },
                co: {
                    default: 'co.png'
                },
                co2: {
                    default: 'coo.png'
                },
                coo: {
                    default: 'coo.png'
                },
                scene: {
                    default: 'scene.png'
                },
                alarm_co: {
                    level: {
                        on: 'co-alarm-on.png',
                        off: 'co-alarm-off.png'
                    }
                },
                alarm_coo: {
                    level: {
                        on: 'coo-alarm-on.png',
                        off: 'coo-alarm-off.png'
                    }
                },
                tamper: {
                    level: {
                        on: 'tamper-on.png',
                        off: 'tamper-off.png'
                    }
                },
                security: {
                    level: {
                        on: 'security-on.png',
                        pending: 'security-pending.png',
                        off: 'security-off.png',
                        alarmed: 'security-alarmed.png'
                    }
                },
                gesture: {
                    level: {
                        press: 'press.png',// pressed / gedrückt
                        hold: 'hold.png',// hold / gedrückt gehalten
                        release: 'release.png',// released / losgelassen
                        swipe_up: 'swipe-up.png',// swiped / berührt
                        swipe_down: 'swipe-down.png',// swiped / berührt
                        swipe_left: 'swipe-left.png',// swiped / berührt
                        swipe_right: 'swipe-right.png',// swiped / berührt
                        swipe_top_left_to_bottom_right: 'swipe-top-left-to-bottom-right.png',// swiped / berührt
                        swipe_top_right_to_bottom_left: 'swipe-top-right-to-bottom-left.png',// swiped / berührt
                        swipe_bottom_left_to_top_right: 'swipe-bottom-left-to-top-right.png',// swiped / berührt
                        swipe_bottom_right_to_top_left: 'swipe-bottom-right-to-top-left.png'// swiped / berührt
                    }
                },
                climatecontrol: {
                    level: {
                        comfort: 'climatecontrol_comfort.png',
                        schedule: 'climatecontrol_schedule.png',
                        energySave: 'climatecontrol_energysave.png',
                        frostProtection: 'climatecontrol_frostprotection.png',
                        default: "climatecontrol_default.png" 
                    }
                },
                valve: {
                    level: {
                        on: 'valve-on.png',
                        off: 'valve-off.png'
                    }
                }
            },
            deviceType: {
                switchControl: {
                    default: 'switch-control.png'
                }
            }
        }
    }
};
