//
//  ZLogging.h
//  Part of Z-Bee.C library
//
//  Created by Kirill Rogozhkin on 28/9/22.
//  Based on Z-Way source code written by Alex Skalozub and Serguei Poltorak
//
//  Copyright (c) 2012 Z-Wave.Me
//  All rights reserved
//  info@z-wave.me
//
//  This source file is subject to the terms and conditions of the
//  Z-Wave.Me Software License Agreement which restricts the manner
//  in which it may be used.
//

#ifndef zbee_logging_h
#define zbee_logging_h

#include "ZLog.h"
#include "ZDefsPublic.h"
#include "ZBeeLib.h"

#define zbee_log(zbee, level, message, ...) zlog_write(zbee_get_logger(zbee), zbee_get_name(zbee), (level), (message), ##__VA_ARGS__)

#define zbee_dump(zbee, level, prefix, length, buffer) zlog_dump(zbee_get_logger(zbee), zbee_get_name(zbee), level, prefix, length, buffer)

#define zbee_log_error(zbee, level, message, err) zlog_error(zbee_get_logger(zbee), zbee_get_name(zbee), (level), (message), (err))

#endif
