//
//  ZDefsPublic.h
//  z-enocean
//
//  Created by Alex Skalozub on 26/06/14.
//
//  Copyright (c) 2014 Z-Wave.Me
//  All rights reserved
//  info@z-wave.me
//

#ifndef zenocean_defs_public_h
#define zenocean_defs_public_h

#include "ZPlatform.h"
#include "ZData.h"
#include "ZMalloc.h"

#ifdef __cplusplus
extern "C" {
#endif

// Z-Enocean instance holder
struct _ZEnocean;
typedef struct _ZEnocean *ZEnocean;

// Definition of termination callback function
typedef void (*ZEnoceanTerminationCallback)(const ZEnocean zeno, void* arg);


// Types of Device change events
enum _ZEDeviceChangeType
{
    ZEDeviceAdded = 0x01,
    ZEDeviceRemoved = 0x02,
    ZEDeviceProfileChanged = 0x04,
    ZEDDXSaved = 0x100, // this callback notifies on ZDDX data change (to allow main program to purge buffers to disk/flash). For this event deviceId = 0
    ZEEnumerateExisting = 0x200, // this flag makes callback immediately fire for all existing devices classes as if they change profile (works with DeviceProfileChanged only)
};
    
// Definition of custom callback for Function Classes calls
typedef void (*ZEJobCustomCallback)(const ZEnocean zeno, ZWBYTE packetType, ZWBYTE commandId, void* arg);

// Use this type to store Device change event type
typedef int ZEDeviceChangeType;

// Definition of device change callback function
typedef void (*ZEnoceanDeviceCallback)(const ZEnocean zeno, ZEDeviceChangeType type, int deviceId, void *arg);
    
// List of NULL terminated registered devices Node Id
typedef unsigned int * ZEDevicesList;
    
#ifdef __cplusplus
}
#endif

#endif
