//
//  ZLogging.h
//  Part of Z-Matter.C library
//
//  Created by Kirill Rogozhkin on 28/9/22.
//  Based on Z-Way source code written by Alex Skalozub and Serguei Poltorak
//
//  Copyright (c) 2012 Z-Wave.Me
//  All rights reserved
//  info@z-wave.me
//
//  This source file is subject to the terms and conditions of the
//  Z-Wave.Me Software License Agreement which restricts the manner
//  in which it may be used.
//

#ifndef zmatter_logging_h
#define zmatter_logging_h

#include "ZLog.h"
#include "ZDefsPublic.h"
#include "ZMatterLib.h"

#define zmatter_log(zmatter, level, message, ...) zlog_write(zmatter_get_logger(zmatter), zmatter_get_name(zmatter), (level), (message), ##__VA_ARGS__)

#define zmatter_dump(zmatter, level, prefix, length, buffer) zlog_dump(zmatter_get_logger(zmatter), zmatter_get_name(zmatter), level, prefix, length, buffer)

#define zmatter_log_error(zmatter, level, message, err) zlog_error(zmatter_get_logger(zmatter), zmatter_get_name(zmatter), (level), (message), (err))

#endif
