//
//  ZTimer.h
//  Part of Z-Way.C library
//
//  Created by Poltorak Serguei on 5/8/17.
//  Based on Z-Way source code written by Christian Paetz and Poltorak Serguei
//
//  Copyright (c) 2017 Z-Wave.Me
//  All rights reserved
//  info@z-wave.me
//
//  This source file is subject to the terms and conditions of the
//  Z-Wave.Me Software License Agreement which restricts the manner
//  in which it may be used.
//

#ifndef zway_timer_h
#define zway_timer_h

typedef void (*ZTimerCallback)(ZWay zway, void * arg);

// Important notice!
// The arg must be fully managed by the caller.
// The caller have to make sure to free the arg if it points to some allocated memory in the following cases:
//  On zway_timer_fire (the caller callback is called)
//  On zway_timer_remove (the caller have to handle arg after this call)
//  On Z-Way stop (the caller have to trap this event by himself)
// zway_timer_add_ex has cancelCallback that can help to manage the allocated memory on timer cancel

ZWEXPORT ZWError zway_timer_add(ZWay zway, float timeout, ZTimer * timer_p, ZTimerCallback callback, void * arg);
ZWEXPORT ZWError zway_timer_add_ex(ZWay zway, float timeout, ZTimer * timer_p, ZTimerCallback callback, ZTimerCallback cancelCallback, void * arg);
ZWEXPORT ZWError zway_timer_remove(ZWay zway, ZTimer timer);
ZWEXPORT ZWError zway_timer_fire(ZWay zway, ZTimer timer);

#endif
