//
//  ByteArray.h
//  z-way-js
//
//  Created by Alex Skalozub on 6/27/12.
//
//  Copyright (c) 2012 Z-Wave.Me
//

#ifndef zway_js_byte_array_h
#define zway_js_byte_array_h

#include "Dependencies.h"

namespace zwjs
{

    class ZWJSEXPORT ByteArray
    {
    public:
        ByteArray();
        ByteArray(size_t len);
        ByteArray(const uint8_t* bytes, size_t len);
        ByteArray(v8::Local<v8::Value> arg);
        ByteArray(const ByteArray &other);
        virtual ~ByteArray();
        
        ByteArray & operator=(const ByteArray & other);
        
        const ZWBYTE* ptr() const;
        size_t size() const;
        
        bool empty() const;
        
        static v8::Handle<v8::Value> toJS(v8::Isolate* isolate, const uint8_t* bytes, size_t len);
        v8::Handle<v8::Value> toJS(v8::Isolate* isolate) const;
        
        static bool canBeArray(v8::Local<v8::Value> arg);
        
    private:
        size_t m_size;
        ZWBYTE *m_bytes;
    };
    
}

#endif
