//
//  Module.h
//  z-way-js
//
//  Created by Alex Skalozub on 21/06/14.
//
//  Copyright (c) 2014 Z-Wave.Me
//

#ifndef zway_js_module_h
#define zway_js_module_h

#include "Dependencies.h"
#include <string>

namespace zwjs
{
    class Environment;
    
    class ZWJSEXPORT Module : public v8::Extension
    {
    public:
        Module(const char* name, const char* source, int dep_count = 0, const char** deps = 0, int source_length = -1);
        
        virtual v8::Handle<v8::FunctionTemplate> GetNativeFunction(v8::Handle<v8::String> name);
        virtual v8::Handle<v8::FunctionTemplate> GetNativeFunctionTemplate(v8::Isolate* isolate, v8::Handle<v8::String> name);
        
        virtual v8::Handle<v8::FunctionTemplate> GetFunction(Environment* env, v8::Isolate* isolate, std::string name) = 0;
    };
    
}

#endif
