//
//  RunResult.h
//  z-way-js
//
//  Created by Alex Skalozub on 2/13/13.
//
//  Copyright (c) 2013 Z-Wave.Me
//

#ifndef zway_js_run_result_h
#define zway_js_run_result_h

#include "Dependencies.h"
#include <string>

namespace zwjs
{

    class ZWJSEXPORT RunResult
    {
    public:
        RunResult() : m_result(), m_isException(false) { }
        RunResult(std::string result, bool isException = false) : m_result(result), m_isException(isException) {};
        RunResult(const RunResult &other) : m_result(other.m_result), m_isException(other.m_isException) {};
        
        std::string result() const { return m_result; }
        bool isException() const { return m_isException; }
    private:
        std::string m_result;
        bool m_isException;
    };
    
}

#endif
