//
//  Threading.h
//  z-way-js
//
//  Created by Alex Skalozub on 7/25/12.
//
//  Copyright (c) 2012 Z-Wave.Me
//

#ifndef zway_js_threading_h
#define zway_js_threading_h

namespace zwjs
{

#ifdef _WINDOWS

    #define THREAD_RESULT DWORD WINAPI
    #define EXIT_THREAD(r) ExitThread((DWORD)r)
    #define CURRENT_THREAD() GetCurrentThread()

    typedef HANDLE ZTHREAD;
    typedef DWORD (WINAPI *ZThreadProc)(void*);

#else

    #define THREAD_RESULT void*
    #define EXIT_THREAD(r) pthread_exit((void*)r);
    #define CURRENT_THREAD() pthread_self()

    typedef pthread_t ZTHREAD;
    typedef THREAD_RESULT (*ZThreadProc)(void*);

#endif

    void ZCreateThread(ZThreadProc proc, void* arg, ZTHREAD* pthread);
    void ZJoinThread(ZTHREAD *pthread);
    void ZDetachThread(ZTHREAD *pthread);

}

#endif
