#!/bin/bash

ZWAY_DIR=/opt/z-way-server/

function factory_defaults()
{
	# Remove only folders
	rm -rf ${ZWAY_DIR}/automation/userModules/*/
	rm -rf ${ZWAY_DIR}/automation/storage/*
	cp ${ZWAY_DIR}/automation/defaultConfigs/config.json ${ZWAY_DIR}/automation/storage/configjson-06b2d3b23dce96e1619d2b53d6c947ec.json
	rm -rf ${ZWAY_DIR}/htdocs/smarthome/user/skins/*
	rm -rf ${ZWAY_DIR}/htdocs/smarthome/user/icons/*
	# Reset Z-Wave
	echo -ne "\x01\x04\x00\x42\x01\xB8" > /dev/ttyAMA0
	echo -ne "\x01\x04\x00\x42\x01\xB8" > /dev/ttyACM0
	rm -rf ${ZWAY_DIR}/config/zddx/*.xml
}

case "$1" in
	start)
		killall z-way-server >/dev/null 2>&1
		factory_defaults
		echo "The administrator password has been reset."
		echo "All automation settings have been removed."
		echo "The RaZberry board with all Z-Wave devices has been reset."
		echo "Start z-way-server with command: sudo /etc/init.d/z-way-server start"
		exit 0
		;;
	check_reset)
		if rm /boot/reset >/dev/null 2>&1; then
			factory_defaults
		fi
		;;
	*)
		echo "Usage: ${ZWAY_DIR}/reset-z-way.sh {start}"
		echo "The admin password will be reset."
		echo "All automation settings will be deleted."
		echo "The RaZberry board with all Z-Wave devices will be reset."
		exit 1
		;;
esac
